{-# OPTIONS_GHC -fglasgow-exts #-}

module DpFramework where {

import List;
import Term;
import Option;
import Fun;

reverse_trs :: forall f v. [(Term f v, Term f v)] -> [(Term f v, Term f v)];
reverse_trs r = mapa (\ lr -> (snd lr, fst lr)) r;

computeRuleMap ::
  forall a b.
    (Eq a) => [(Term a b, Term a b)] -> Maybe (a -> [(Term a b, Term a b)]);
computeRuleMap [] = Just (\ f -> []);
computeRuleMap ((Fun f ts, r) : rules) =
  (case computeRuleMap rules of {
    Nothing -> Nothing;
    Just rm -> Just (fun_upd rm f ((Fun f ts, r) : rm f));
  });
computeRuleMap ((Var uu, uv) : rules) = Nothing;

}
